VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "ComboBox DropUp"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkDropUp 
      Caption         =   "Combo DropUP"
      Height          =   285
      Left            =   2640
      TabIndex        =   3
      Top             =   750
      Value           =   1  'Checked
      Width           =   1725
   End
   Begin VB.ListBox lst1 
      Appearance      =   0  'Flat
      Height          =   1590
      Left            =   270
      TabIndex        =   1
      Top             =   765
      Visible         =   0   'False
      Width           =   2160
   End
   Begin VB.ComboBox cbo1 
      Height          =   315
      Left            =   270
      TabIndex        =   0
      Top             =   2340
      Width           =   2190
   End
   Begin VB.Label lblInfo 
      Caption         =   "Sample to show how to drop UP a ComboBox"
      Height          =   525
      Left            =   270
      TabIndex        =   2
      Top             =   210
      Width           =   3945
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' Module    : Form1
' DateTime  : 23/09/2003 23.08
' Author    : gibra
'           : email:   vbcorner@vbcorner.net
'           : website: http://www.vbcorner.net
' Purpose   : This project simulate a DropDown event in
'              a combobox but the listbox is displayed UP the combo
'              instead of Down.
'              The tricks is displayed a hidden ListBox which contains then
'              same items of the combo, and force the combo to stay close!
'              This may be made without subclassing! Only use API for
'              mimic the 'mousemove' effect on combobox which focus the
'              item under the mouse pointer. See Module1.bas for how to.
'              If you ave any suggestion please contact me
'
' Updates   :  september 25, 2003
'              Now all the Key is implemented. Thank to:
'              Roger Gilchrist <rojagilkrist@hotmail.com>
'              Note: see the ComboDropUP_Roger updates.txt
'
'---------------------------------------------------------------------------------------
Option Explicit


'/ used to simulate mousemove on ComboBox
Dim bMouseMove As Boolean
Private bOpen As Boolean
Private CmboUP As Boolean
Private Sub cbo1_Change()
   Debug.Print "Event cbo1_Change"
End Sub


Private Sub cbo1_Click()
   Debug.Print "Event cbo1_Click"
   lst1.ListIndex = cbo1.ListIndex

End Sub


Private Sub cbo1_DropDown()
'/ The tips to simulate the DropDown opened UP is :
'/ 1. Intercept the opening of combo (when user click to the arrow)
'/    and force it to stay close
'/ 2. Open a hidden ListBox instead
'/ 3. If the ListBox is visible, close it.

'Static bOpen As Boolean

   '/ Switch to Open or Close the combo
   'If chkDropUp Then
   If CmboUP Then
      
      If bOpen Then
         bOpen = False
         '/ Close combo
         Debug.Print "Event cbo1_DropDown: Close combo"
         SendKeys "%{DOWN}"
         lst1.Visible = False
         cbo1.SetFocus
         bMouseMove = False
      Else
         
         '/ Open combo
         bOpen = True
         Debug.Print "Event cbo1_DropDown: Open combo"
         SendKeys "%{DOWN}"
         lst1.Visible = True
         If cbo1.Text = "" Then lst1.ListIndex = -1
         bMouseMove = True
         lst1.SetFocus
         
      End If
      
      
   End If
   
End Sub



Private Sub chkDropUp_Click()
   '/ add by Roger
   CmboUP = chkDropUp.Value = vbChecked
   If CmboUP = False And lst1.Visible Then ' if the list is visible when the check box is clicked then hide it
      lst1.Visible = False
   End If
End Sub

Private Sub Form_Load()

   'CmboUP = True
   CmboUP = chkDropUp.Value
   
   '/ simply populate ComboBox and ListBox
   With cbo1
      .AddItem "One"
      .AddItem "Two"
      .AddItem "Three"
      .AddItem "For"
      .AddItem "Five"
      .AddItem "Six"
      .AddItem "Seven"
      .AddItem "Eight"
      .AddItem "Nine"
      .AddItem "Ten"
   End With
   With lst1
      .AddItem "One"
      .AddItem "Two"
      .AddItem "Three"
      .AddItem "For"
      .AddItem "Five"
      .AddItem "Six"
      .AddItem "Seven"
      .AddItem "Eight"
      .AddItem "Nine"
      .AddItem "Ten"
   End With
   
End Sub


Private Sub lst1_Click()

   '/ if bMouseMove is True, the user move the mouse
   '/ over the listbox. Need intercept this otherwise
   '/ the item is selected and the listbox is close!
   '/ See the MouseMove event of this listbox
   If bMouseMove Then Exit Sub
   
   '/ when user select a item
   '/ 1. the same item is selected on combobox
   '/ 2. hide the listbox and focus the combo
   cbo1.ListIndex = lst1.ListIndex
   lst1.Visible = False
   cbo1.SetFocus
   
   bOpen = False
   
End Sub


Private Sub lst1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

   '/ to close the listbox when the user click a item set to False
   bMouseMove = False
   
End Sub


Private Sub lst1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'/ move the hilight selection on the item under the mouse
'/ to mimic the same feature when the user move the mouse of the combobox

Dim cx As Long, cy As Long, nIndex As Long
   
   
   '/ mouse coordinates
   cx = X \ Screen.TwipsPerPixelX
   cy = Y \ Screen.TwipsPerPixelY
   
   nIndex = ItemFromPoint(lst1, cx, cy)
   
   ' Debug.Print nIndex
   
   '/ ---------------------------------
   '/ Hilight the item under the cursor
   '/ Note: Normally, this comand select the item,
   '/       but the bMouseMove variable force the listbox
   '/       to stay opened!   See MouseDown event also.
   lst1.Selected(nIndex) = True
   cbo1.ListIndex = lst1.ListIndex '<<<<<<<<<<New code
   '/ ---------------------------------
   
End Sub


Private Sub lst1_KeyUp(KeyCode As Integer, Shift As Integer)
Select Case KeyCode
  Case vbKeyUp, vbKeyDown, vbKeyLeft, vbKeyRight
  cbo1.ListIndex = lst1.ListIndex
  Case vbKeyReturn
  bOpen = False '<<This is why you move bOpen
                '(Also Declaration declares use about 1/3 of memory compared to Static)
  lst1.Visible = False
End Select
End Sub
